
/*
This Java source file was generated by test-to-java.xsl
and is a derived work from the source document.
The source document contained the following notice:



Copyright (c) 2001-2004 World Wide Web Consortium, 
(Massachusetts Institute of Technology, Institut National de
Recherche en Informatique et en Automatique, Keio University).  All 
Rights Reserved.  This program is distributed under the W3C's Software
Intellectual Property License.  This program is distributed in the 
hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  

See W3C License http://www.w3.org/Consortium/Legal/ for more details.


*/

package org.w3c.domts.level3.core;

import org.w3c.dom.*;


import org.w3c.domts.DOMTestCase;
import org.w3c.domts.DOMTestDocumentBuilderFactory;



/**
 *  Create a new Element node, add new Text, Element and Processing Instruction nodes to it.
 *  Using compareDocumentPosition, compare the position of the Element with respect to the Text
 *  and the Text with respect to the Processing Instruction.
* @author IBM
* @author Jenny Hsu
* @see <a href="http://www.w3.org/TR/2003/CR-DOM-Level-3-Core-20031107/core#Node3-compareDocumentPosition">http://www.w3.org/TR/2003/CR-DOM-Level-3-Core-20031107/core#Node3-compareDocumentPosition</a>
*/
public final class nodecomparedocumentposition34 extends DOMTestCase {

   /**
    * Constructor.
    * @param factory document factory, may not be null
    * @throws org.w3c.domts.DOMTestIncompatibleException Thrown if test is not compatible with parser configuration
    */
   public nodecomparedocumentposition34(final DOMTestDocumentBuilderFactory factory)  throws org.w3c.domts.DOMTestIncompatibleException {
      super(factory);

    //
    //   check if loaded documents are supported for content type
    //
    String contentType = getContentType();
    preload(contentType, "hc_staff", false);
    }

   /**
    * Runs the test case.
    * @throws Throwable Any uncaught exception causes test to fail
    */
   public void runTest() throws Throwable {
      Document doc;
      Element elemMain;
      Element elem;
      Text txt;
      ProcessingInstruction pi;
      int elementToTxtPosition;
      int txtToPiPosition;
      Node appendedChild;
      doc = (Document) load("hc_staff", false);
      elemMain = doc.createElementNS("http://www.w3.org/1999/xhtml", "p");
      elem = doc.createElementNS("http://www.w3.org/1999/xhtml", "br");
      txt = doc.createTextNode("TEXT");
      pi = doc.createProcessingInstruction("PIT", "PID");
      appendedChild = elemMain.appendChild(txt);
      appendedChild = elemMain.appendChild(elem);
      appendedChild = elemMain.appendChild(pi);
      elementToTxtPosition = (int) txt.compareDocumentPosition(elem);
      assertEquals("nodecomparedocumentpositionFollowing34", 4, elementToTxtPosition);
      txtToPiPosition = (int) pi.compareDocumentPosition(txt);
      assertEquals("nodecomparedocumentpositionPRECEDING34", 2, txtToPiPosition);
      }
   /**
    *  Gets URI that identifies the test.
    *  @return uri identifier of test
    */
   public String getTargetURI() {
      return "http://www.w3.org/2001/DOM-Test-Suite/level3/core/nodecomparedocumentposition34";
   }
   /**
    * Runs this test from the command line.
    * @param args command line arguments
    */
   public static void main(final String[] args) {
        DOMTestCase.doMain(nodecomparedocumentposition34.class, args);
   }
}

